<?php

namespace Drupal\color_picker_field\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'color_picker_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "color_picker_formatter",
 *   label = @Translation("Color Picker"),
 *   field_types = {
 *     "color_picker"
 *   }
 * )
 */
class ColorPickerFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      $elements[$delta] = [
        '#markup' => '<span style="color: ' . $item->value . ';">' . $item->value . '</span>',
      ];
    }
    return $elements;
  }

}
